<template>
  <BaseMap
    ref="map"
    :style="mapStyle"
    :zoom="16"
    :overlays-config="mapOverlays"
    activate-locate-control
    hide-locate-control
    :locate-control-on-error-handler="locateControlOnErrorHandler"
    :locate-control-on-update-handler="locateControlOnUpdateHandler"
    :locate-control-on-heading-handler="locateControlOnHeadingHandler"
    :locate-control-on-permission-denied-handler="locateControlOnPermissionDeniedHandler"
    locate-control-enable-high-accuracy
    locate-control-use-gnss-position
    :add-satellite-image="false"
    map-class="map-photo"
  >
    <template
      #map-inner-content
    >
      <div class="leaflet-control-reduce-container">
        <div
          class="leaflet-control-reduce"
        >
          <q-btn
            color="accent"
            size="xs"
            @click="$emit('hide')"
          >
            <q-icon
              name="las la-chevron-down"
            />
          </q-btn>
        </div>
      </div>
    </template>
  </BaseMap>
</template>

<script>
import BaseMap from 'src/components/BaseMap'
import { getDefaultOverlayLayersConfig, getHoldingCampaignPlotsLayer } from 'src/services/map/layers/layer-configs'

export default {
  name: 'TakePhotoMap',
  components: {
    BaseMap
  },
  props: {
    locateAtStart: {
      type: Boolean,
      default: true
    },
    mapStyle: {
      type: String,
      default: ''
    },
    plotId: {
      type: Number,
      default: null
    }
  },
  emits: ['hide', 'geolocation-unavailable', 'geolocation-update', 'geolocation-permission-denied', 'heading-update'],
  computed: {
    mapOverlays () {
      const overlays = getDefaultOverlayLayersConfig()

      // add the holding campaign plots
      const holdingCampaignPlotsLayer = {
        ...getHoldingCampaignPlotsLayer(true, { holdingCampaignId: this.$store.state.fastplatform.holdingCampaign.id }),
        currentPlotId: this.plotId,
        hideCurrentPlot: this.plotId != null
      }
      overlays.push(holdingCampaignPlotsLayer)

      // add the selected plot in a separate plot to make sure it is not drawn over by other plots
      if (this.plotId != null) {
        const plotLayer = {
          ...getHoldingCampaignPlotsLayer(true, { plotId: this.plotId }),
          title: this.$pgettext('Plot of agricultural land', 'Selected plot'),
          currentPlotId: this.plotId,
          highlighted: true
        }
        overlays.push(plotLayer)
      }
      return overlays
    }
  },
  methods: {
    locateControlOnErrorHandler (err) {
      this.$emit('geolocation-unavailable', err)
    },
    locateControlOnUpdateHandler (position) {
      this.$emit('geolocation-update', position)
    },
    locateControlOnHeadingHandler (heading) {
      this.$emit('heading-update', heading)
    },
    locateControlOnPermissionDeniedHandler (isAppGeolocationPermissionDenied) {
      this.$emit('geolocation-permission-denied', isAppGeolocationPermissionDenied)
    },
    startLocate () {
      // call the base map startLocateControl function
      this.$refs.map.startLocateControl()
    },
    stopLocate () {
      // call the base map stopLocateControl function
      this.$refs.map.stopLocateControl()
    }
  }
}
</script>
